commit 1c4d4f690042f978c44f4307960dcf9652e0db43
Author: jklowden <jklowden>
Date:   Fri Jan 22 22:41:47 2010 +0000

    error message when hostfile wider than table

diff --git a/ChangeLog b/ChangeLog
index 4c2fbb7..d6f7d4e 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Fri Jan 22 17:39:39 EST 2010	JK Lowden <jklowden@freetds.org>
+	* src/dblib/bcp.c error message when hostfile wider than table.
+
 Fri Jan 22 13:40:35 CET 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* configure.ac freetds.spec.in misc/prepare_win32.sh:
 	* misc/test-dist.sh:
@@ -2156,4 +2159,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2947 2010/01/22 12:42:13 freddy77 Exp $
+$Id: ChangeLog,v 1.2948 2010/01/22 22:41:47 jklowden Exp $
diff --git a/src/dblib/bcp.c b/src/dblib/bcp.c
index db4bac0..692409c 100644
--- a/src/dblib/bcp.c
+++ b/src/dblib/bcp.c
@@ -62,7 +62,7 @@
 #define MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #endif
 
-TDS_RCSID(var, "$Id: bcp.c,v 1.191 2010/01/10 14:43:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: bcp.c,v 1.192 2010/01/22 22:41:48 jklowden Exp $");
 
 #ifdef HAVE_FSEEKO
 typedef off_t offset_type;
@@ -1151,13 +1151,22 @@ _bcp_read_hostfile(DBPROCESS * dbproc, FILE * hostfile, int *row_error)
 		 * FIXME I think tab_colnum can be out of range - freddy77
 		 */
 		if (hostcol->tab_colnum) {
+			if (hostcol->tab_colnum > dbproc->bcpinfo->bindinfo->num_cols) {
+				tdsdump_log(TDS_DBG_FUNC, "error: file wider than table: %d/%d\n", 
+							  i+1, dbproc->bcpinfo->bindinfo->num_cols);
+				dbperror(dbproc, SYBEBEOF, NULL);
+				return FAIL;
+			}
+			tdsdump_log(TDS_DBG_FUNC, "host column %d uses bcpcol %d (%p)\n", 
+				                  i+1, hostcol->tab_colnum, bcpcol);
 			bcpcol = dbproc->bcpinfo->bindinfo->columns[hostcol->tab_colnum - 1];
+			assert(bcpcol != NULL);
 		}
 
 		/* detect prefix len */
 		if (bcpcol && hostcol->prefix_len == -1) {
-			int plen = bcpcol->column_varint_size;
-			hostcol->prefix_len = plen == 5 ? 4 : plen;
+			int len = bcpcol->column_varint_size;
+			hostcol->prefix_len = len == 5 ? 4 : len;
 		}
 
 		/* a prefix length, if extant, specifies how many bytes to read */

